<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsCommerce3 extends JPlugin
{
	function plgAnalyticsCommerce3( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'commerce3') return;
		
		$data = array('amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if( $name != 'commerce3' ) return;
		global $mainframe;

		if( !JComponentHelper::isEnabled('com_commerce', true) ) {
			$errors = '<h3>Mighty Commerce Component Not Exists or Not Enabled<h3>';
			return;
		}

	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Top customers</b>]]>",90 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'commerce3' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'commerce3' ) return;
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$max = $params->get( 'max' );

		$groupby = $params->get('groupby', 'sday');

		$order_by = $params->get('top_by', 0) ? 'price' : 'total';
		$section = $params->get('sections');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$sql = "
		SELECT COUNT(ord.id) as total, IF(u.username IS NULL, '".JText::_('Unregistered')."', u.username) as username, ord.section_id,
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__users u ON ord.user_id = u.id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		GROUP BY ord.user_id
		ORDER BY $order_by DESC
		LIMIT 0, ".$max;
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;

		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));
		$total = 0;
		foreach ($result AS $key => $row)
		{
		    $objChart->addSerie($key,$row->username);
//			$series[] = "<value xid='{$key}'>".ucfirst($row->username)."</value>";
			if($params->get('top_by', 0))
			{
				$value = $row->price;
				$descr = JText::_('Sales').': '.str_replace(array("00", "Sign"), array($row->price, $curr->mark), $CP->get('comm_layout_price'));
			}
			else
			{
				$value = $row->total;
				$descr = $descr = JText::_('Orders total').': '.$row->total;
			}
			$graph1[$row->username][] = array( 'value' => $value, 'description' => $descr );
//			$graph1[] = "<value xid='{$key}' description='{$descr}'>{$value}</value>";
		}
	    foreach( $graph1 as $key => $graph ) {
			$objChart->addGraph($key, $key, $graph, array( 
				'balloon_text' => '<![CDATA[{description}]]>',
			));
		}
/*		$key = $params->get('top_by', 0);
		$out = "<chart><series>";
		$out .= implode("", $series);
		$out .= "</series>";
		$out .= "<graphs><graph gid='{$key}' baloon_text='{description}'>";
		$out .= implode("", $graph1);
		$out .= "</graph></graphs></chart>";

		$data = $out;*/
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'commerce3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$max = $params->get( 'max' );
		$groupby = $params->get( 'groupby', 'sday' );
		$limit = $params->get('limit', 0);

		$sort_by = $params->get('sort_by');
		$section = $params->get('sections');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$sql = "
		SELECT IF(u.username IS NULL, '".JText::_('Unregistered')."', u.username) as username, ord.section_id,";
		$sql .= $params->get('top_by', 0) ? "
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as total" : "COUNT(ord.id) as total ";
		$sql .= " FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__users u ON ord.user_id = u.id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		GROUP BY ord.user_id
		ORDER BY ".($sort_by ? $sort_by : "total DESC")
		." LIMIT 0, ".($limit ? $limit : $max);

		$db->setQuery($sql);
		$result = $db->loadObjectList(); 

		if( !$result ) return;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('User').'</th>';
		$out[] = '<th width="10%">'.($params->get('top_by', 0) ? JText::_('Sales amount'): JText::_('Orders total')).'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$k = 0;
		$r = 0;
		$total = 0;

		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));

		foreach ( $result AS $p => $row ) {

			$out[] = "<tr class='row".$k."'>
				<td>".( $p + 1 )."</td>
				<td nowrap>".ucfirst($row->username)."</td>
				<td align='right' nowrap>";
			$out[] = $params->get('top_by', 0) ? str_replace(array("00", "Sign"), array($row->total, $curr->mark), $CP->get('comm_layout_price')) : $row->total;
			$out[] = "</td>
				</tr>";
			$total += $row->total;
		}
		
		$out[] = "<tr class='row".$k."'>
				<td colspan='2' align='right'><big><b>".JText::_('Total')."</b></big></td>
				<td align='right' nowrap><big><b>";
			$out[] = $params->get('top_by', 0) ? str_replace(array("00", "Sign"), array($total, $curr->mark), $CP->get('comm_layout_price')) : $total;
			$out[] = "</b></big></td>
				</tr>";
		$out[] = '</table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'commerce3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));
		$max = $params->get( 'max' );
		$groupby = $params->get('groupby', 'sday');

		$section = $params->get('sections');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$totals = array();
		$order_by = $params->get('top_by', 0) ? 'price' : 'total';

		$sql = "SELECT ";
		$sql .= $params->get('top_by', 0) ? "
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price " : "COUNT(ord.id) as total ";
		$sql .= " FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__users u ON ord.user_id = u.id
		WHERE  ord.section_id  = '$section' ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		ORDER BY $order_by DESC";

		$db->setQuery( $sql );
		$db_totals = $db->loadResult();
		if(!$db_totals) return;

		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));

		$totals[0]['value'] = $params->get('top_by', 0) ?  str_replace(array("00", "Sign"), array($db_totals, $curr->mark), $CP->get('comm_layout_price')) : $db_totals;
		$totals[0]['text'] = $params->get('top_by', 0) ? JText::_( 'Total sales in DB') : JText::_( 'Total orders in DB');

		$sql = " SELECT ";
		$sql .= $params->get('top_by', 0) ? "
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price " : "COUNT(ord.id) as total ";
		$sql .= "
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__users u ON ord.user_id = u.id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to'  AND ord.section_id = '$section' ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		ORDER BY  $order_by DESC";

		$db->setQuery( $sql );
		$rep_totals = $db->loadResult();

		if(!$rep_totals) return;
		$procent = '';
		if($rep_totals > 0)
		$procent = ' <small><i>('.round($rep_totals / $db_totals * 100, 1).'%)</i></small>';
		$totals[1]['value'] = ($params->get('top_by', 0) ?  str_replace(array("00", "Sign"), array($rep_totals, $curr->mark), $CP->get('comm_layout_price')) : $rep_totals).$procent;
		$totals[1]['text'] = $params->get('top_by', 0) ? JText::_( 'Total sales in this report') : JText::_( 'Total orders in this report');

		$sql = "SELECT  IF(u.username IS NULL, '".JText::_('Unregistered')."', u.username) as username, ";
		$sql .= $params->get('top_by', 0) ? "
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price" : "COUNT(ord.id) as total ";
		$sql .= "
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__users u ON ord.user_id = u.id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section' ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= " GROUP BY ord.user_id
		ORDER BY $order_by DESC";

		$db->setQuery( $sql );
		if($res = $db->loadObject())
		{
			$procent = '';
			$value = $params->get('top_by', 0) ? $res->price : $res->total;
			if($value > 0)
			$procent = ' ('.round($value / $rep_totals * 100, 1).'%)';
			$text = $params->get('top_by', 0) ?  JText::_('sales') : JText::_('orders')  ;
			$totals[2]['value'] = ($params->get('top_by', 0) ?  str_replace(array("00", "Sign"), array($value, $curr->mark), $CP->get('comm_layout_price')) : $value)
			.' <small><i>'.$text.$procent.'</i></small>';
			$totals[2]['text'] = '<b>'.ucfirst($res->username).'</b> '.JText::_( 'has');
		}
		return $totals;
	}

	function getCurrency($id)
	{
		$db =& JFactory::getDBO();
		$query = "
		SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
		FROM #__jc_currency AS c
		WHERE c.id = '$id'";
		$db->setQuery( $query);
		return $db->loadObject();
	}
}
?>