<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsCommerce5 extends JPlugin
{
	function plgAnalyticsCommerce5( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
     function onGetChartTypes(&$data, $name) {
		
		if($name != 'commerce5') return;
		
		$data = array('amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if( $name != 'commerce5' ) return;
		global $mainframe;

		if( !JComponentHelper::isEnabled('com_commerce', true) ) {
			$errors = '<h3>Mighty Commerce Component Not Exists or Not Enabled<h3>';
			return;
		}

	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Bestsellers</b>]]>",90 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'commerce5' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'commerce5' ) return;
			
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$max = $params->get( 'max' );

		$section = $params->get('sections');

		$sql = "
		SELECT SUM(pr.amount) as total, u.username, rec.title
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__js_res_record rec ON pr.product_id = rec.id
		LEFT JOIN #__users u ON u.id = rec.user_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		GROUP BY pr.product_id
		HAVING total > 0
		ORDER BY total DESC
		LIMIT 0, ".$max;
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;

		foreach ($result AS $key => $row)
		{
			$objChart->addSerie($key,$row->title);
			$graphs[$row->title][] = array('xid' => $key, 'description' => JText::_('Seller').': '.ucfirst($row->username), 'value' => $row->total);
		}
		foreach( $graphs as $key => $graph ) {
			$objChart->addGraph($key, $key, $graph, array( 
				'balloon_text' => '<![CDATA[{value} items {description}]]>',
			));
		} 
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'commerce5') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$max = $params->get( 'max' );
		$limit = $params->get('limit', 0);

		$sort_by = $params->get('sort_by');
		$section = $params->get('sections');

		$sql = "
		SELECT SUM(pr.amount) as total, u.username, rec.title
		FROM #__jc_orders AS ord
		INNER JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		INNER JOIN #__js_res_record rec ON pr.product_id = rec.id
		INNER JOIN #__users u ON u.id = rec.user_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= "
		GROUP BY pr.product_id
		HAVING total > 0
		ORDER BY ".($sort_by ? $sort_by : 'total DESC').
		" LIMIT 0, ".($limit ? $limit : $max);
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if( !$result ) return;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Product').'</th>';
		$out[] = '<th class="title">'.JText::_('Seller').'</th>';
		$out[] = '<th width="10%">'.JText::_('Total sales').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$k = 0;
		$r = 0;
		$total = 0;

		foreach ( $result AS $p => $row ) {

			$out[] = "<tr class='row".$k."'>
				<td>".( $p + 1 )."</td>
				<td nowrap>".ucfirst($row->title)."</td>
				<td nowrap>".ucfirst($row->username)."</td>
			<td align='right' nowrap>{$row->total}</td>
			</tr>";
			$total += $row->total;
		}

		$out[] = "<tr class='row".$k."'>
				<td colspan='3' align='right'><big><b>".JText::_('Total')."</b></big></td>
		<td align='right' nowrap><big><b>{$total}</b></big></td>
		</tr>";
		$out[] = '</table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'commerce5') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));
		$max = $params->get( 'max' );

		$section = $params->get('sections');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$totals = array();
		$order_by = $params->get('top_by', 0) ? 'price' : 'total';

		$sql = "SELECT SUM(pr.amount) as total
		FROM #__jc_orders AS ord
		INNER JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		WHERE  ord.section_id  = '$section' ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";

		$db->setQuery( $sql );
		$db_totals = $db->loadResult();
		if(!$db_totals) return;

		$totals[0]['value'] = $db_totals;
		$totals[0]['text'] = JText::_( 'Total products sold in DB');

		$sql = " SELECT SUM(pr.amount) as total
		FROM #__jc_orders AS ord
		INNER JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to'  AND ord.section_id = '$section' ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";

		$db->setQuery( $sql );
		$rep_totals = $db->loadResult();
		if(!$rep_totals) return;

		$totals[1]['value'] = $rep_totals.' <small><i>('.round($rep_totals / $db_totals * 100, 1).'%)</i></small>';;
		$totals[1]['text'] = JText::_( 'Total products sold in this report');

		$sql = "
		SELECT SUM(pr.amount) as total, u.username, rec.title
		FROM #__jc_orders AS ord
		INNER JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		INNER JOIN #__js_res_record rec ON pr.product_id = rec.id
		INNER JOIN #__users u ON u.id = rec.user_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id  = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND ord.user_id = '$user_id'";
		$sql .= " GROUP BY pr.product_id
		HAVING total > 0
		ORDER BY total DESC";

		$db->setQuery( $sql );
		if($res = $db->loadObject())
		{
			$totals[2]['value'] = $res->total.' <small><i> ('.round($res->total / $rep_totals * 100, 1).'%)</i></small>';
			$totals[2]['text'] = JText::_('items of').' <b>'.$res->title.'</b> '.JText::_('are sold');
		}
		return $totals;
	}

	function getCurrency($id)
	{
		$db =& JFactory::getDBO();
		$query = "
		SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
		FROM #__jc_currency AS c
		WHERE c.id = '$id'";
		$db->setQuery( $query);
		return $db->loadObject();
	}
}
?>