<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsCommerce6 extends JPlugin
{
	function plgAnalyticsCommerce6( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'commerce6') return;
		
		$data = array('amline', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if( $name != 'commerce6' ) return;
		global $mainframe;

		if( !JComponentHelper::isEnabled('com_commerce', true) ) {
			$errors = '<h3>Mighty Commerce Component Not Exists or Not Enabled<h3>';
			return;
		}

	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Products sales progress</b>]]>",90 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'commerce6' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'commerce6' ) return;
		
		$type = $params->get('chart_type');
			
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );


		$groupby = $params->get('groupby', 'sday');
		$section = $params->get('sections');
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$date_index = Array(  "sday"   => "DATE_FORMAT( ord.ctime, '%Y-%m-%d' )",
		                      "sweek"  => "DATE_FORMAT( ord.ctime - INTERVAL WEEKDAY(ord.ctime) DAY, '%Y-%m-%d' )",
		                      "smonth" => "DATE_FORMAT( ord.ctime, '%Y-%m-01' )",
		                      "syear"  => "DATE_FORMAT( ord.ctime, '%Y-01-01' )");
		$sql = "
		SELECT SUM(pr.amount) as total, rec.title, pr.product_id,
		{$date_index[$groupby]}  AS date_index,
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price,
		DAYOFYEAR(ord.ctime) as sday,
		WEEKOFYEAR(ord.ctime) as sweek,
		MONTH(ord.ctime) AS smonth, YEAR(ord.ctime) AS syear,
		DATE_FORMAT(ord.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(ord.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(ord.ctime , '%b') AS dat_smonth,
		DATE_FORMAT(ord.ctime , '%Y') AS dat_syear
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$sql .= "
		GROUP BY pr.product_id, `{$groupby}`
		ORDER BY ord.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;

		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));
			
		foreach ( $result AS $key => $row ) {
			$graphs[$row->product_id][$row->date_index] = array('value' => $row->total, 'description' => str_replace(array("00", "Sign"), array($row->price, $curr->mark), $CP->get('comm_layout_price')) );
			$product[$row->product_id] = $row->title;
		}
		$current_date = $from;

	    switch ( $groupby ) {
			case "sday":
				$format_series 		= '%Y %d %b';
				break;
			case "sweek" :
				$timestamp = strtotime( $current_date );
				$date_info = getdate($timestamp);
				$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %UW';
				break;
			case "smonth" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %b';
				break;
			case "syear" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y';
				break;
		}

		while ( strtotime( $current_date ) <= strtotime( $to ) ) {

            $serie = strftime( $format_series, strtotime( $current_date ) );
			$objChart->addSerie($current_date,$serie);
			if ( $type == 'amline')
			{
    			foreach( $graphs as $key => $graph) {
    				if( !isset($graphs[$key][$current_date]) ) {
    					$graphs[$key][$current_date] = " 0 ";
    				}
    			}
			}
			$current_date = $this->incrementDate( $current_date, $groupby );
		}
		foreach( $graphs as $key => $graph ) {
			$objChart->addGraph($key, $product[$key], $graph, array( 
				'balloon_text' => '<![CDATA[{value} '.JText::_('items').': {description}]]>',
			));
		} 
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'commerce6') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$groupby = $params->get( 'groupby', 'sday' );
		$limit = $params->get('limit', 0);

		$section = $params->get('sections');
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');


		$date_index = Array(  "sday"   => "DATE_FORMAT( ord.ctime, '%Y-%m-%d' )",
		                      "sweek"  => "DATE_FORMAT( ord.ctime - INTERVAL WEEKDAY(ord.ctime) DAY, '%Y-%m-%d' )",
		                      "smonth" => "DATE_FORMAT( ord.ctime, '%Y-%m-01' )",
		                      "syear"  => "DATE_FORMAT( ord.ctime, '%Y-01-01' )");
		$sql = "
		SELECT SUM(pr.amount) as total, rec.title, pr.product_id,
		{$date_index[$groupby]}  AS date_index,
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price,
		DAYOFYEAR(ord.ctime) as sday,
		WEEKOFYEAR(ord.ctime) as sweek,
		MONTH(ord.ctime) AS smonth, YEAR(ord.ctime) AS syear,
		DATE_FORMAT(ord.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(ord.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(ord.ctime , '%b') AS dat_smonth,
		DATE_FORMAT(ord.ctime , '%Y') AS dat_syear
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$sql .= "
		GROUP BY pr.product_id, `{$groupby}`
		ORDER BY ord.ctime";

		if($limit)
		$sql .= " LIMIT 0, $limit";

		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if( !$result ) return;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th width="5%">'.JText::_('Date').'</th>';
		$out[] = '<th class="title">'.JText::_('Product').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '<th width="1%">'.JText::_('Sales').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$k = 0;
		$total = 0;
		$sales = 0;


		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));
		foreach ( $result AS $p => $row ) {
			$out[] = "<tr class='row".$k."'>
				<td>".( $p + 1 )."</td>
				<td nowrap>".$row->{"dat_".$groupby}."</td>
				<td nowrap>".$row->title."</td>
				<td align='right'>".$row->total."</td>				
				<td align='right' nowrap>".str_replace(array("00", "Sign"), array($row->price, $curr->mark), $CP->get('comm_layout_price'))."</td>
				</tr>";
			$total += $row->total;
		}

		$out[] = '<tr><td colspan="3" align="right"><b>'.JText::_( 'Total' ).'</b></td>
						<td align="right"><b><big>'.$total.'</big></b></td>
						<td></td>
						</tr></tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'commerce6') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$section = $params->get('sections');
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

		$totals = array();

		$sql = "
		SELECT SUM(pr.amount) as total,
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		WHERE ord.section_id = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$db->setQuery( $sql );
		$db_totals = $db->loadObject();

		if(!$db_totals) return;

		$CP = ResHelper::getSectionParams($section);
		$curr = $this->getCurrency($CP->get('comm_core_currency'));


		$totals[0]['value'] = $db_totals->total; 
		$totals[0]['text'] = JText::_( 'Items totally in DB');

		$totals[1]['value'] = str_replace(array("00", "Sign"), array($db_totals->price, $curr->mark), $CP->get('comm_layout_price'));  //.' <small><i>'.JText::_('items').'</i></small>';
		$totals[1]['text'] = JText::_( 'Sales totally in DB');

		$sql = "
		SELECT SUM(pr.amount) as total,
		ROUND(SUM((pr.price * pr.amount) + pr.tax - pr.discount - pr.refund), 2) as price
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$db->setQuery( $sql );
		$rep_totals = $db->loadObject();

		if(!$rep_totals || !$rep_totals->total) return;

		$totals[2]['value'] = $rep_totals->total.' <small><i>('.round($rep_totals->total / $db_totals->total * 100, 1).'%)</i></small>';;
		$totals[2]['text'] = JText::_( 'Items in this report');

		$procent = round($rep_totals->price / $db_totals->price * 100, 1);
		$totals[3]['value'] = str_replace(array("00", "Sign"), array($rep_totals->price, $curr->mark), $CP->get('comm_layout_price'))
		.' <small><i>('.$procent.'%)</i></small>';;
		$totals[3]['text'] = JText::_( 'Sales in this report');

		return $totals;
	}

	function getCurrency($id)
	{
		$db =& JFactory::getDBO();
		$query = "
		SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
		FROM #__jc_currency AS c
		WHERE c.id = '$id'";
		$db->setQuery( $query);
		return $db->loadObject();
	}

    function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>