<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsCommerce8 extends JPlugin
{
	function plgAnalyticsCommerce8( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'commerce8') return;
		
		$data = array('amline', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if( $name != 'commerce8' ) return;
		global $mainframe;

		if( !JComponentHelper::isEnabled('com_commerce', true) ) {
			$errors = '<h3>Mighty Commerce Component Not Exists or Not Enabled<h3>';
			return;
		}

	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Products properties progress</b>]]>",90 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'commerce8' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}
	

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'commerce8' ) return;
		
		$type = $params->get('chart_type');
			
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$groupby = $params->get('groupby', 'sday');
		$section = $params->get('sections');

		$field = $params->get('field');
		if(!$field)
		    return;
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';


		$date_index = Array(  "sday"   => "DATE_FORMAT( ord.ctime, '%Y-%m-%d' )",
		                      "sweek"  => "DATE_FORMAT( ord.ctime - INTERVAL WEEKDAY(ord.ctime) DAY, '%Y-%m-%d' )",
		                      "smonth" => "DATE_FORMAT( ord.ctime, '%Y-%m-01' )",
		                      "syear"  => "DATE_FORMAT( ord.ctime, '%Y-01-01' )");
		$sql = "
		SELECT DISTINCT(prop.property), COUNT(prop.id) total,
		{$date_index[$groupby]}  AS date_index,
		DAYOFYEAR(ord.ctime) as sday,
		WEEKOFYEAR(ord.ctime) as sweek,
		MONTH(ord.ctime) AS smonth,
		YEAR(ord.ctime) AS syear,
		DATE_FORMAT(ord.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(ord.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(ord.ctime , '%b') AS dat_smonth,
		DATE_FORMAT(ord.ctime , '%Y') AS dat_syear
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__jc_orders_products_property AS prop ON prop.order_product_id = pr.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		LEFT JOIN #__js_res_fields f ON f.id = prop.prop_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section' AND prop.prop_id = '$field'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$sql .= "
		GROUP BY prop.property, `{$groupby}`
		ORDER BY ord.ctime, total DESC";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;

		$total = 0;
			
		foreach ( $result AS $key => $row ) {
			$graphs[$row->property][$row->date_index] = $row->total;
		}
		$current_date = $from;

	    switch ( $groupby ) {
			case "sday":
				$format_series 		= '%Y %d %b';
				break;
			case "sweek" :
				$timestamp = strtotime( $current_date );
				$date_info = getdate($timestamp);
				$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %UW';
				break;
			case "smonth" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y %b';
				break;
			case "syear" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				$format_series      = '%Y';
				break;
		}

		while ( strtotime( $current_date ) <= strtotime( $to ) ) {

			$serie = strftime( $format_series, strtotime( $current_date ) );
			$objChart->addSerie($current_date,$serie);

			foreach( $graphs as $key => $graph) {
    			if ( $type == 'amline')
    			{
    				foreach( $graphs as $key => $graph) {
    					if( !isset($graphs[$key][$current_date]) ) {
    						$graphs[$key][$current_date] = " 0 ";
    					}
    				}
    			}
			}

			$current_date = $this->incrementDate( $current_date, $groupby );
		}

		$sql = "SELECT type FROM #__js_res_fields WHERE id = '$field'";
		$db->setQuery($sql);
		$type = $db->loadResult();
		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields', $type);

		/*$out = "<chart>";

		$out .= "<series>";
		$out .= implode("", $series);
		$out .= "</series>";

		$out .= "<graphs>";*/

		foreach( $graphs as $key => $graph ) {
			$value = $key;
			$dispatcher->trigger('onRenderPropertyValue', array ($type, &$value));
			$value = str_replace("<sup>", ":", $value);
			$value = strip_tags($value);
			$objChart->addGraph($key, $value, $graph, array( 
				'balloon_text' => '<![CDATA[{value}]]>',
			));
	/*		$out .= "<graph gid='".$key."' title='{$value}' line_width='2' balloon_text='{value} '>";
			$out .= implode( "", $graph );
			$out .= "</graph>";*/
		}

	/*	$out .= "</graphs>";

		$out .= "</chart>";

		$data = $out;*/
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'commerce8') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$groupby = $params->get( 'groupby', 'sday' );
		$limit = $params->get('limit', 0);

		$section = $params->get('sections');
		$field = $params->get('field');
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';

		$date_index = Array(  "sday"   => "DATE_FORMAT( ord.ctime, '%Y-%m-%d' )",
		                      "sweek"  => "DATE_FORMAT( ord.ctime - INTERVAL WEEKDAY(ord.ctime) DAY, '%Y-%m-%d' )",
		                      "smonth" => "DATE_FORMAT( ord.ctime, '%Y-%m-01' )",
		                      "syear"  => "DATE_FORMAT( ord.ctime, '%Y-01-01' )");
		$sql = "
		SELECT DISTINCT(prop.property), COUNT(prop.id) total,
		{$date_index[$groupby]}  AS date_index,
		DAYOFYEAR(ord.ctime) as sday,
		WEEKOFYEAR(ord.ctime) as sweek,
		MONTH(ord.ctime) AS smonth,
		YEAR(ord.ctime) AS syear,
		DATE_FORMAT(ord.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(ord.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(ord.ctime , '%b') AS dat_smonth,
		DATE_FORMAT(ord.ctime , '%Y') AS dat_syear
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__jc_orders_products_property AS prop ON prop.order_product_id = pr.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		LEFT JOIN #__js_res_fields f ON f.id = prop.prop_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section' AND prop.prop_id = '$field'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$sql .= "
		GROUP BY prop.property, `{$groupby}`
		ORDER BY ord.ctime";

		if($limit)
		$sql .= " LIMIT 0, $limit";

		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if( !$result ) return;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th width="5%">'.JText::_('Date').'</th>';
		$out[] = '<th class="title">'.JText::_('Property').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$k = 1;
		$total = 0;

		$sql = "SELECT type FROM #__js_res_fields WHERE id = '$field'";
		$db->setQuery($sql);
		$type = $db->loadResult();
		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields', $type);

		foreach ( $result AS $p => $row ) {
			$value = $row->property;
			$dispatcher->trigger('onRenderPropertyValue', array ($type, &$value));
			$out[] = "<tr class='row".($k % 2 + 1)."'>
				<td>".( $p + 1 )."</td>
				<td nowrap>".$row->{"dat_".$groupby}."</td>
				<td nowrap>".$value."</td>
				<td align='right'>".$row->total."</td>
				</tr>";
			$total += $row->total;
			$k ++;
		}

		$out[] = '<tr><td colspan="3" align="right"><b>'.JText::_( 'Total' ).'</b></td>
						<td align="right"><b><big>'.$total.'</big></b></td>
						<td></td>
						</tr></tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'commerce8') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = 0;
		if($params->get('user_stick'))
		{
			$user_id = $user->id;
		}
		if($user->gid == 25) $user_id = JRequest::getInt('user_id', $user_id);

		$db = JFactory::getDBO();

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');
		$section = $params->get('sections');
		$field = $params->get('field');
		$index = $params->get('user_type', 0) ? 'ord.user_id' : 'pr.seller_id';

		$totals = array();

		$sql = "
		SELECT COUNT(prop.id) as total
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__jc_orders_products_property AS prop ON prop.order_product_id = pr.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		LEFT JOIN #__js_res_fields f ON f.id = prop.prop_id
		WHERE ord.section_id = '$section' AND prop.prop_id = '$field'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";

		$db->setQuery( $sql );
		$db_totals = $db->loadResult();

		if(!$db_totals) return;


		$totals[0]['value'] = $db_totals;
		$totals[0]['text'] = JText::_( 'Properties total in DB');

		$sql = "
		SELECT COUNT(prop.id) as total
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__jc_orders_products_property AS prop ON prop.order_product_id = pr.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		LEFT JOIN #__js_res_fields f ON f.id = prop.prop_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section' AND prop.prop_id = '$field'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";

		$db->setQuery( $sql );
		$rep_totals = $db->loadResult();

		if(!$rep_totals) return $totals;

		$totals[2]['value'] = $rep_totals.' <small><i>('.round($rep_totals / $db_totals * 100, 1).'%)</i></small>';
		$totals[2]['text'] = JText::_( 'Properties total in this report');


		$sql = "
		SELECT DISTINCT(prop.property), COUNT(prop.id) total
		FROM #__jc_orders AS ord
		LEFT JOIN #__jc_orders_products AS pr ON pr.order_id = ord.id
		LEFT JOIN #__jc_orders_products_property AS prop ON prop.order_product_id = pr.id
		LEFT JOIN #__js_res_record rec ON rec.id = pr.product_id
		LEFT JOIN #__js_res_fields f ON f.id = prop.prop_id
		WHERE ord.ctime > '$from' AND ord.ctime < '$to' AND ord.section_id = '$section' AND prop.prop_id = '$field'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND $index = '$user_id'";
		$sql .= "
		GROUP BY prop.property
		ORDER BY total DESC";

		$db->setQuery($sql);
		if($result = $db->loadObjectList())
		{
			$pop = array();
			foreach ($result as $i => $val)
			{
				if($i == 0)
				$pop[] = $val;
				if(isset($result[$i+1]->total) && $result[$i+1]->total == $val->total)
				$pop[] = $result[$i+1];
				else break;

			}
			$i = 3;
			if(count($pop) && count($pop) < count($result))
			{
				$sql = "SELECT type FROM #__js_res_fields WHERE id = '$field'";
				$db->setQuery($sql);
				$type = $db->loadResult();
				$dispatcher =& JDispatcher::getInstance();
				JPluginHelper::importPlugin('joomsuite_content_fields', $type);
				foreach ($pop as $val)
				{
					$value = $val->property;
					$dispatcher->trigger('onRenderPropertyValue', array ($type, &$value));
					$totals[$i]['value'] = '<small><i>'.$value.'</i></small>';
					$totals[$i]['text'] = JText::_( 'was selectes').' <b>'.$val->total.'</b> '.JText::_('times');
					$i++;
				}
			}
		}
		return $totals;
	}

	function getCurrency($id)
	{
		$db =& JFactory::getDBO();
		$query = "
		SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
		FROM #__jc_currency AS c
		WHERE c.id = '$id'";
		$db->setQuery( $query);
		return $db->loadObject();
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>